// ---------------------------------------------------------------------------
//	OPM-like Sound Generator
//	Copyright (C) cisc 1998, 2003.
// ---------------------------------------------------------------------------

#ifndef FM_OPM_H
#define FM_OPM_H

#include "fmgen.h"
#include "fmtimer.h"
#include "psg.h"

// ---------------------------------------------------------------------------
//	class OPM
//	OPM ɤ(?)벻˥å
//	
//	interface:
//	bool Init(uint clock, uint rate, bool);
//		Υ饹Ѥˤʤ餺ƤǤȡ
//		: 䴰⡼ɤѻߤޤ
//
//		clock:	OPM Υåȿ(Hz)
//
//		rate:	 PCM ɸܼȿ(Hz)
//
//				
//			 true
//
//	bool SetRate(uint clock, uint rate, bool)
//		å PCM 졼Ȥѹ
//		 Init Ʊ͡
//	
//	void Mix(Sample* dest, int nsamples)
//		Stereo PCM ǡ nsamples ʬ dest ǻϤޤ
//		ä(û)
//		dest ˤ sample*2 ʬΰ褬ɬ
//		Ǽ L, R, L, R... Ȥʤ롥
//		ޤǲûʤΤǡ餫򥼥ꥢɬפ
//		FM_SAMPLETYPE  short ξ祯åԥ󥰤Ԥ.
//		δؿϲΥޡȤΩƤ롥
//		  Timer  Count  GetNextEvent ɬפ롥
//	
//	void Reset()
//		ꥻå()
//
//	void SetReg(uint reg, uint data)
//		Υ쥸 reg  data 񤭹
//	
//	uint ReadStatus()
//		Υơ쥸ɤ߽Ф
//		busy ե饰Ͼ 0
//	
//	bool Count(uint32 t)
//		Υޡ t [10^(-6) ] ʤ롥
//		֤Ѳä(timer Сե)
//		true ֤
//
//	uint32 GetNextEvent()
//		ΥޡΤɤ餫СեޤǤɬפ
//		[]֤
//		ޡߤƤ 0 ֤
//	
//	void SetVolume(int db)
//		Ʋβ̤ܡĴ᤹롥ɸͤ 0.
//		ñ̤ 1/2 dBͭϰϤξ¤ 20 (10dB)
//
//	۴ؿ:
//	virtual void Intr(bool irq)
//		IRQ ϤѲäƤФ롥
//		irq = true:  IRQ ׵᤬ȯ
//		irq = false: IRQ ׵᤬ä
//
namespace FM
{
	//	YM2151(OPM) ----------------------------------------------------
	class OPM : public Timer
	{
	public:
		OPM();
		virtual ~OPM() {}

		bool	Init(uint c, uint r, bool=false);
		bool	SetRate(uint c, uint r, bool);
		void	SetLPFCutoff(uint freq);
		void	Reset();
		
		void 	SetReg(uint addr, uint data);
		uint	GetReg(uint addr);
		uint	ReadStatus() { return status & 0x03; }
		
		void 	Mix(Sample* buffer, int nsamples, int rate, BYTE* pbsp, BYTE* pbep);
		
		void	SetVolume(int db);
		void	SetChannelMask(uint mask);
		
	private:
		virtual void Intr(bool) {}
	
	private:
		enum
		{
			OPM_LFOENTS = 512,
		};
		
		void	SetStatus(uint bit);
		void	ResetStatus(uint bit);
		void	SetParameter(uint addr, uint data);
		void	TimerA();
		void	RebuildTimeTable();
		void	MixSub(int activech, ISample**);
		void	MixSubL(int activech, ISample**);
		void	LFO();
		uint	Noise();
		
		int		fmvolume;

		uint	clock;
		uint	rate;
		uint	pcmrate;

		uint	pmd;
		uint	amd;
		uint	lfocount;
		uint	lfodcount;

		uint	lfo_count_;
		uint	lfo_count_diff_;
		uint	lfo_step_;
		uint	lfo_count_prev_;

		uint	lfowaveform;
		uint	rateratio;
		uint	noise;
		int32	noisecount;
		uint32	noisedelta;
		
		bool	interpolation;
		uint8	lfofreq;
		uint8	status;
		uint8	reg01;

		uint8	kc[8];
		uint8	kf[8];
		uint8	pan[8];

		Channel4 ch[8];
		Chip	chip;

		static void	BuildLFOTable();
		static int amtable[4][OPM_LFOENTS];
		static int pmtable[4][OPM_LFOENTS];

	public:
		int		dbgGetOpOut(int c, int s) { return ch[c].op[s].dbgopout_; }
		Channel4* dbgGetCh(int c) { return &ch[c]; }

	};
}

#endif // FM_OPM_H
